#define ANALOG_PIN 6
uint16_t g_wLast = 0;
uint32_t g_lSum = 0;
uint16_t g_wCnt = 0;
boolean g_fPrintData;

static const uint8_t g_abBtns[] = "123A456B789C0FED";

void setup() {
  delay(2000);
  Serial.begin(38400);
  
  // Quick and dirty have simple way to print values again if needed
  uint16_t w = analogRead(ANALOG_PIN);
  delay(10);
  w = analogRead(ANALOG_PIN);  // sometimes first read can be off...
  g_fPrintData = (w > 100);  // probably some button pressed when we started...
  
}

void loop() {
  if (g_fPrintData) {
    PrintRawStuff();
    return;
  }

  uint16_t w = analogRead(ANALOG_PIN);
  uint8_t iBtn = MapAnalogToButton(w);
  
  if (iBtn != 0xff) {
    Serial.print(w, DEC);
    Serial.print(" ");
    Serial.print(iBtn, DEC);
    Serial.print("->");
    Serial.write(g_abBtns[iBtn]);
    Serial.println();
    do {
      delay(50);
    } while (MapAnalogToButton(analogRead(ANALOG_PIN)) != 0xff);
  }
   delay(50);  // debounce time 
}

void PrintRawStuff(void) {
  
  uint16_t w = analogRead(ANALOG_PIN);
  if (abs(w - g_wLast) > 10) {
    if (g_wCnt > 5) {
      Serial.print (g_wCnt, DEC);
      Serial.print(" ");
      Serial.print(g_lSum/g_wCnt, DEC);
      Serial.print(" ");
      Serial.println((uint16_t)(15-(log((analogRead(A0)-183.9)/58.24)/0.1623)+0.5), DEC);
      g_wCnt = 0;
      g_lSum = 0;
    }
    Serial.println(w, DEC);
    g_wLast = w;
  }
  g_lSum += w;
  g_wCnt++;
  delay(20);
}

uint8_t MapAnalogToButton(uint16_t wAnalog) {
  // Quick and dirty.
  if (wAnalog > 950)                      //1012
    return 15;  // to much delta...
  if (wAnalog > 650)
    return (wAnalog - 696 + 46)/93 + 12;    //696, 772, 882
  if (wAnalog > 445)
    return (wAnalog - 478 + 24)/48 + 8;    //478, 514, 559, 608
  if (wAnalog > 333)
    return (wAnalog - 348 + 19)/22 + 4;    //348, 366, 390, 413
  if (wAnalog > 260)
    return (wAnalog - 276 + 6)/13;          // 276, 290, 304, 317
  return 0xff;  // error  
}
